/* Demonstration file for TWISTER V1.00 & DKB Raytracer*/
/* On an IBM-PC 386/20 with 387 coproc. this file takes 3 min at 80 X 60 res */
/* and 2 hours for a 320 X 240 anti-aliased image. */
/* See TWISTER.DOC for more details. - DW Dec '90*/

/* Declare a sphere so basicshape.dat won't be needed. */
#declare Sphere = quadric { <1.0 1.0 1.0> <0.0 0.0 0.0> <0.0 0.0 0.0> -1.0 }

camera {
    location <0.0 20.0 -50.0>
    direction <0.0 0.0 2.0>
    up <0.0 1.0 0.0>
    right <1.33333 0.0 0.0>
    look_at <0.0 10.0 0.0>
}

/* Twist.dat is the default file generated by TWISTER.COM */
/* It includes the UNION Macaroni and the QUADRIC Part.   */
/* NOTE - DKB V2.04 & earlier can only use ONE include file */
/*         This has been corrected in V2.05 & later.*/
#include "twist.pov"

/* Here is the twister */
/* It can be rotated, scaled and transformed normally.*/
/* Change color and texture in the UNION declaration. */
object {
 Macaroni
 texture {
   ambient 0.3
   color red 1 green 0 blue 0
 }
}

/* Put down transparent checkered floor */
object {
   plane { <0.0 1.0 0.0> -3.0 }
   texture {
      ambient 0.3
      checker color red 1.0 blue 1.0 green 1.0 alpha 1.0 
              color red 0.3 green 1.0 blue 0.3
      scale < 20.0 20.0 20.0 >      
   }
}

/* Put down a SUB-floor */
object {
   plane { <0.0 1.0 0.0> -7.0 }
   texture {
       ambient 0.1
       diffuse 0.9
       color red 1.0 green 1.0 blue 1.0
   }
}

/* Create a sky */

object {
 sphere { <0.0 0.0 0.0> 200.0 inverse  }
 texture {
     ambient 0.4
     color red 0.5 green 0.5 blue 1.0
 }
}


/*The Sun*/
object {
   light_source { <50.0 90.0 -130.0>
   color red 1.0 green 1.0 blue 1.0
   }
}

